**    ModelEco : MODELisation en programmation mathmatique pour l'analyse ECOnomique de l'agriculure    **

*-----------------------------------------------------------------------------*
$Ontext
Nom              modelEco_Lauragais1.gms
Sequence         3 - Le risque et le temps dans les modles
Langage GAMS     sqr, sqrt, LOOP
Type             NLP
Description
" Une exploitation agricole du Lauragais, rgion du sud-ouest de la France, compte 200 ha de surface agricole
dont 100 ha sont irrigus. Sur cette exploitation, travaillent une agricultrice et son mari ,
les deux sont des travailleurs qualifis.
L'agricultrice commercialise sa production via une cooprative agricole locale trs implique dans la production
et la commercialisation de semences. Elle  a ainsi le choix entre deux types de production,
des grandes cultures destines au march de l'alimentation humaine ou animale et des cultures
pour la production de semences, produites sous contrat avec la cooprative.
Les grandes cultures qu'elle peut produire ( destination des marchs  de l'alimentation humaine ou animale) sont :
bl tendre, bl dur, soja et tournesol. Les cultures destines  la production des semences,
concernent le mas et des cultures potagres : concombre, chou, betterave, carotte, oignon et persil.
Les cultures destines  la production de semences sont beaucoup plus rentables,
mais les exigences de qualit de la cooprative sont trs strictes et certaines annes,
les conditions climatiques ne permettent pas d'atteindre la qualit prvue dans le cahier des charges.
Le prix qui dpend de la qualit s'en ressent. Dans certains cas, la cooprative peut refuser la totalit de la rcolte.
La marge brute de cette production est alors nulle.
Les cultures de semences sont consommatrices de main d'uvre non qualifie, pour la rcolte.
Ce travail est entirement salari et doit tre surveill par un travailleur qualifi (familial ou salari lui aussi).
On compte un travailleur qualifi pour surveiller 20 travailleurs non qualifis. Un travailleur salari coute 11.1/heure
et un travailleur qualifi 73.3/heure. Les charges fixes de l'exploitation sont de 93293.
L'agricultrice peut louer des terres  ses voisins avec un prix du fermage de 519.
Les charges pour chaque culture sont divises en trois types, les charges oprationnelles hors main-d'uvre,
les charges spcifiques et les charges de main-d'uvre salarie.
Les cultures ne demandent pas le mme travail chaque mois de l'anne.
Seules les grandes cultures demandent du travail qualifi, il s'agit du travail mcanis.
Les cultures de semences ont elles des forts besoins en main-d'uvre non qualifie lors des rcoltes.
Les prix de vente sont : 25 pour le bl dur, 14 pour le bl tendre, 35 pour le tournesol et 36 pour le soja.
L'objectif de l'agricultrice est de maximiser son revenu."


Modele Lauragais 1994
*reference: Jacquet F -Legrusse Ph- Risk in farmer decision-making :
*Combining economic and management approaches.
*Communication au 38eme seminaire de l'AEEA, Copenhague, novembre 1994
$offtext

*-----------------------------------------------------------------------------*


*----------                          INDICES                        ----------*

SETS
C        cultures                /bleDur,bleTendre,tournesol,soja,mais_S,
                                 bett_S,conc_S,carot_S,oignon_S,choux_S,persil_S/
CI(C)    cultures irrigables     /mais_S,soja,bett_S,conc_S,carot_S,oignon_S,choux_S,persil_S/
CG(C)    cultures semences       /bett_S,conc_S,carot_S,oignon_S,choux_S,persil_S/
M        mois                    /M1*M12/
E        etats de la nature      /E1* E10/
sc       scnario                /sc1*sc5/

AV       aversion au risque      /A1*A5/
;

*----------                          DONNEES                        ----------*
*---------------------les valeurs monetaires sont en euros--------------------*

SCALARS

SAU      surface de l'exploitation en hectares           /200/
ISAU     surface irrigable                               /100/
UTH      nombre de travailleurs familiaux  (qualifi)     /2/
PTM      prix travail manuel (non qualifi)              /11.1/
PTS      prix travail entreprise (qualifi)              /73.3/
CSG      charges de structures                           /93293/
PF       prix du fermage (location de terre)             /519/
S        surveillance de la main d oeuvre un pour vingt  /0.05/
Z0       revenu minimal

A        aversion au risque
;

parameter
AA(AV) coefficient d'aversion au risque
/A1  0,A2 0.5,A3  1,A4 2,A5 2.5/
;

parameter
revMin(sc) different revenu minimum
/sc1 -1000000, sc2 0, sc3 70000, sc4 110000, sc5 150000/


PARAMETERS

CO(C) charges operationnelles hors main d oeuvre en  par ha
/
bleDur        379
bleTendre     379
tournesol     258
soja          777
mais_S       1814
bett_s       3369
conc_s       1175
carot_s      1743
oignon_s     3964
choux_s      3109
persil_s      826
/

CS(C) charges specifiques par culture en  par ha
/
bleDur        488
bleTendre     488
tournesol     488
soja          488
mais_S        488
bett_s       1244
conc_s       1244
carot_s      1244
oignon_s     1244
choux_s      1244
persil_s     1244
/

MO(M) heures travail totales disponibles en heures par UTH
/m1 112,m2 120,m3 104,m4 112,m5 104,m6 136,
m7 160,m8 144,m9 152,m10 136,m11 128,m12 128/

PI(C)  prix (en euros par quintal) ou recettes pour les semences
/
bleDur        23.5
bleTendre     14
tournesol     35
soja          36
mais_S        1
bett_s        1
conc_s        1
carot_s       1
oignon_s      1
choux_s       1
persil_s      1
/


TABLE
HT(c,m)      besoins en travail mecanise grandes cultures (qualifi) (en heures pa ha)
               m1   m2   m3   m4    m5  m6  m7   m8   m9   m10  m11    m12
bleDur         1    0.5  0.5  0.5   0.5     1.5       0.5  1.5   2.5   0.5
bleTendre      1    0.5  0.5  0.5   0.5     1.5       0.5  1.5   2.5   0.5
tournesol            1.5  1.5  2    1                            2
mais_S         0     1    1   4.5   3    2  3.5   2    1    0    2      0
soja           0     1.5  1.5  1   1.5  1.5  2    0.5  0    1
;

TABLE
MOO(c,m)   besoins en main d oeuvre manuelle non qualifie (en heures pa ha)
           m1   m2   m3   m4    m5  m6  m7   m8   m9  m10  m11  m12
mais_S                                       120
bett_s     50        5     5    5    5   5    5    5    5
conc_s                          5    5   5    5       100
carot_s              5    5     5    5   5    5              5    5
oignon_s                                120       80
choux_s                                 100      100
persil_s             5    5     5

;

TABLE RA(C,E) rendements en quintaux pour cereales et en euros pour semences
              E1       E2       E3       E4       E5       E6       E7       E8       E9       E10
bleDur        68      76.5      73.1     76.5     74.8     73.1     71.4     76.5     74.8     66.3
bleTendre     59.5    76.5      73.1     68       74.8     79.9     74.8     73.1     69.7     81.6
tournesol     49.3    47.6      42.5     45.9     44.2     49.3     34       42.5     45.9     30.6
soja          47.6    49.3      45.9     49.3     47.6     34       45.9     47.6     44.2     51
mais_S      6477     7774     6997      389     3888     6477    10367     9122     8293    10185
bett_s         0     9503     8553     6479    11662     3109     9071     6479    13476    17192
conc_s       726     9433     7257        0    13994     8293     7257     8034    11662     5909
carot_s        0     7257     5806     9848      376     9848     8811     6479     6997     2630
oignon_s   13994    10367     9330    11662    14773    11662        0     9071     9071     3369
choux_s     7237    15550    11662    16845    22029    13994        0    16845     8293     4146
persil_s       0     7252     5076     6479     8293     5702     3499     5442     3888     5137
;

parameter rdtMoyen ;
rdtMoyen(C)=sum(E, RA(C,E)/card(E));
display rdtMoyen;

parameter chargesNQ;
chargesNQ(C)=sum(M,MOO(C,M)*PTM);
display chargesNQ;


*----------                         CALCULS                          ----------*
parameter MBA(C,E) marge brute alatoire ;
MBA(C,E)=RA(C,E)*PI(C)-CO(C)-sum(m,moo(c,m)*ptm);

parameter mb(c) marge brute moyenne par culture ;
mb(c)= sum[e, RA(C,E)*PI(C)]/card(E)-cs(C) - CO(C) - sum[m,moo(c,m)*ptm] ;


*----------                         MODELE                          ----------*

 VARIABLES
 Z        objectif
 R        revenu global
 ETR      ecarttype du revenu
 X(C)     surface par culture
 H        location de terre
 T(m)     travail d'entreprise
 RAL(E)   revenu aleatoire

 ;
POSITIVE VARIABLES X,T,H ;

EQUATION
Objectif    fonction objectif
Revenu      revenu
ecarttypeR   ecart type du revenu
terre       contrainte de terre
travail(m)  contrainte de travail qualifie
irrigation  contrainte de disponibilites en terre irriguable
revenual(E) equation de calcul du revenu aleatoire

;

 objectif ..     R-A*ETR =e= Z;

 revenu ..       sum[C,X(C)*mb(C)]-sum[m,T(m)*pts]-H*pf-csg =e=R ;
*total des marges brutes moins les couts spcifique - total du prix du travail salari moins prix de la location des terres moins les charges de structure

 terre ..        sum(C,X(C))=l=sau+H;

 irrigation ..   sum(CI,x(CI))=l=isau;
*somme des surfaces des cultures irrigables doit tre infrieur  la disponibilit en surface irrigable

 travail(m) ..   sum(C,ht(C,M)*x(C))+sum(C,moo(C,M)*x(C)*s) =l= mo(M)*uth+T(M);
*par mois [travail mcanis total et surveillance du travail manuel total ]
*doit etre infrieur  [main doeuvre qualifie familiale multipli par le nb d'UTH plus le travail d'entreprise qualifi]

 revenual(E)..   sum(C,X(C)*(mba(C,E)-cs(C)))-sum(M,T(M)*pts)-H*pf-csg=e=RAL(E);
*pour chaque etat de la nature, calcul du revenu

 ecarttypeR ..    sqrt (sum (E, sqr(RAL(E)-R))/card(E))=e= ETR;


Model lauragais /ALL/ ;

*----------                        SOLUTION                         ----------*

parameter result(*,*,*);
LOOP(AV, A=AA(AV);
SOLVE lauragais USING NLP MAXIMIZING Z ;

result(C,'HA',AV)=X.L(C);
result('SAU','HA',AV)=sum(c,X.L(C));
result('locter','HA',AV)=H.L;
result('Revenu_MOY','EUROS',AV)=R.L;
result('REVENU',E,AV)=RAL.L(E);
result('ET_revenu','EUROS',AV)=ETR.L;
result('travail','HEURES_AN',AV)=sum(m,t.L(m));
result('model','status',av)= lauragais.modelStat ;
);
option result:2:2:1;

display result,mb,mba, rdtMoyen;

 ;
